/**
* crype
*/

#include <cstdio>
#include <vector>

struct crype {
public:
	crype() : in(stdin), out(stdout), total_chains(0) { };
	
	void set_encryption_key(std::string& pass_str);
	bool encrype();
	bool decrype();

	FILE *in, *out;
	unsigned int total_chains;

	typedef std::vector<unsigned char> buff_t;

protected:

	void handle_enc(buff_t& buff);
	void handle_zip_enc(buff_t& buff);
	void handle_unzip(buff_t& chain);
	void handle_chain_unzip_enc(buff_t& buff);

	unsigned char enckey[32];

};
